use std::path::PathBuf;
use pest::Parser;
use deimos::ast::build::build_ast;
use deimos::ast::unparse::Unparse;
use deimos::parser::{DeimosParser, Rule};

pub fn unparse(path: &PathBuf) {
    let src = std::fs::read_to_string(path).expect(&format!("Could not read {:?}", path));
    let parse_result = DeimosParser::parse(Rule::CompilationUnit, &src);
    match parse_result {
        Ok(mut pairs) => {
            let compilation_unit_pair = pairs.next().unwrap();
            let compilation_unit = build_ast(compilation_unit_pair);
            let mut out = String::new();
            compilation_unit.unparse(&mut out).expect("Failed to write to string.");
            println!("{}", out);
        },
        Err(e) => {
            eprintln!("{}", e);
        }
    }
}
